<?php

	require("_init.php");
	require("_connect.php");
	require("_funcdb.php");
	require("_funcstd.php");

	$perintahdb = "CREATE DATABASE IF NOT EXISTS " . DATABASE_NAME . " DEFAULT CHARACTER SET utf8 DEFAULT COLLATE utf8_general_ci";

	if ( @DBQuery( $perintahdb ) ) {
		echo "Database baru berhasil dibuat.<br>";
	} else {
		die( "Error membuat database: " . DBError() . "<br>" );
	}


	$bukadb = DBSelect( DATABASE_NAME );

	if (!$bukadb) {
		die( "Error membuka database: " . DATABASE_NAME . "   " . DBError() . "\n" );
	}

	$versilama = 0;

	$perintahdb = "SELECT DBVersion FROM tblcontrol";

	if ( $querycols = @DBQuery( $perintahdb ) ) {

		if ( $queryrow = @DBFetchAssoc($querycols) ) {

			$versilama = $queryrow['DBVersion'];

			if ( $versilama >= DATABASE_VERSION ) {
				die( "Your database already up to date!<br>" . "DB Version: " . $queryrow['DBVersion'] . "   SetupDB Version: " . DATABASE_VERSION );
			}

		}

	}

	$perintahstruct = array();

	$perintahstruct['tblcontrol'] = array();
	$perintahstruct['tblcontrol']['DBVersion']					= "smallint unsigned NOT NULL";
	$perintahstruct['tblcontrol']['PrimaryKey']					= "DBVersion";
	$perintahstruct['tblcontrol']['UniqueKey']					= array();
	$perintahstruct['tblcontrol']['UniqueKey']['DBVersion']		= "DBVersion";

	$perintahstruct['tbluser'] = array();
	$perintahstruct['tbluser']['UserID']						= "smallint unsigned NOT NULL AUTO_INCREMENT";
	$perintahstruct['tbluser']['User']							= "char(20) NOT NULL";
	$perintahstruct['tbluser']['Password']						= "char(20) NOT NULL";
	$perintahstruct['tbluser']['Level']							= "tinyint unsigned";
	$perintahstruct['tbluser']['LastLogin']						= "datetime";
	$perintahstruct['tbluser']['PasswordWrong']					= "tinyint(3)";
	$perintahstruct['tbluser']['PasswordWrongLast']				= "datetime";
	$perintahstruct['tbluser']['InputBy']						= "smallint signed";
	$perintahstruct['tbluser']['InputDateTime']					= "datetime";
	$perintahstruct['tbluser']['LastEditBy']					= "smallint signed";
	$perintahstruct['tbluser']['LastEditDateTime']				= "datetime";
	$perintahstruct['tbluser']['DeleteBy']						= "smallint signed";
	$perintahstruct['tbluser']['DeleteDateTime']				= "datetime";
	$perintahstruct['tbluser']['PrimaryKey']					= "UserID";
	$perintahstruct['tbluser']['UniqueKey']						= array();
	$perintahstruct['tbluser']['UniqueKey']['UserID']			= "UserID";
	$perintahstruct['tbluser']['UniqueKey']['User']				= "User";

	$perintahstruct['tblcabang'] = array();
	$perintahstruct['tblcabang']['KodeCabang']					= "smallint unsigned NOT NULL";
	$perintahstruct['tblcabang']['NamaCabang']					= "varchar(100) NOT NULL";
	$perintahstruct['tblcabang']['InputBy']						= "smallint signed";
	$perintahstruct['tblcabang']['InputDateTime']				= "datetime";
	$perintahstruct['tblcabang']['LastEditBy']					= "smallint signed";
	$perintahstruct['tblcabang']['LastEditDateTime']			= "datetime";
	$perintahstruct['tblcabang']['PrimaryKey']					= "KodeCabang";
	$perintahstruct['tblcabang']['UniqueKey']					= array();
	$perintahstruct['tblcabang']['UniqueKey']['KodeCabang']		= "KodeCabang";

	$perintahstruct['tblpelang'] = array();
	$perintahstruct['tblpelang']['KodeCabang']					= "smallint unsigned NOT NULL";
	$perintahstruct['tblpelang']['Kode']						= "char(20) NOT NULL";
	$perintahstruct['tblpelang']['Tipe']						= "tinyint unsigned";
	$perintahstruct['tblpelang']['Group_Pel']					= "varchar(30)";
	$perintahstruct['tblpelang']['Group_Pe2']					= "varchar(30)";
	$perintahstruct['tblpelang']['Pel_Gabung']					= "boolean";
	$perintahstruct['tblpelang']['PJ_Reserv']					= "boolean";
	$perintahstruct['tblpelang']['PJ_Quotat']					= "boolean";
	$perintahstruct['tblpelang']['PJ_SalReq']					= "boolean";
	$perintahstruct['tblpelang']['PJ_SalOrd']					= "boolean";
	$perintahstruct['tblpelang']['PJ_KlrStk']					= "boolean";
	$perintahstruct['tblpelang']['PJ_Eceran']					= "boolean";
	$perintahstruct['tblpelang']['PJ_Cash']						= "boolean";
	$perintahstruct['tblpelang']['PJ_Credit']					= "boolean";
	$perintahstruct['tblpelang']['PJ_Cabang']					= "boolean";
	$perintahstruct['tblpelang']['PJ_RetCash']					= "boolean";
	$perintahstruct['tblpelang']['PJ_RetCrd']					= "boolean";
	$perintahstruct['tblpelang']['PJ_DN']						= "boolean";
	$perintahstruct['tblpelang']['PJ_CN']						= "boolean";
	$perintahstruct['tblpelang']['PJ_Deposit']					= "boolean";
	$perintahstruct['tblpelang']['PJ_Invoice']					= "boolean";
	$perintahstruct['tblpelang']['PJ_Har_Lst']					= "boolean";
	$perintahstruct['tblpelang']['Tgl_Daftar']					= "date";
	$perintahstruct['tblpelang']['NPWP']						= "varchar(30)";
	$perintahstruct['tblpelang']['NPWP_Nama']					= "varchar(50)";
	$perintahstruct['tblpelang']['NPWP_Alamat']					= "varchar(150)";
	$perintahstruct['tblpelang']['Title']						= "tinyint unsigned";
	$perintahstruct['tblpelang']['Nama']						= "varchar(80)";
	$perintahstruct['tblpelang']['Alamat']						= "varchar(150)";
	$perintahstruct['tblpelang']['Kode_Pos']					= "varchar(5)";
	$perintahstruct['tblpelang']['Daerah']						= "varchar(30)";
	$perintahstruct['tblpelang']['Daerah2']						= "varchar(30)";
	$perintahstruct['tblpelang']['Negara']						= "varchar(30)";
	$perintahstruct['tblpelang']['Agama']						= "tinyint unsigned";
	$perintahstruct['tblpelang']['No_KTP']						= "varchar(30)";
	$perintahstruct['tblpelang']['Jenis_Kel']					= "tinyint unsigned";
	$perintahstruct['tblpelang']['Tmp_Lahir']					= "varchar(30)";
	$perintahstruct['tblpelang']['Tgl_Lahir']					= "date";
	$perintahstruct['tblpelang']['Sts_Pers']					= "varchar(20)";
	$perintahstruct['tblpelang']['Pend_Akhir']					= "varchar(20)";
	$perintahstruct['tblpelang']['Telepon']						= "varchar(20)";
	$perintahstruct['tblpelang']['Telepon_2']					= "varchar(20)";
	$perintahstruct['tblpelang']['Telepon_3']					= "varchar(20)";
	$perintahstruct['tblpelang']['Fax']							= "varchar(20)";
	$perintahstruct['tblpelang']['Hubungi']						= "varchar(30)";
	$perintahstruct['tblpelang']['Hub_Telp_1']					= "varchar(20)";
	$perintahstruct['tblpelang']['Hubungi_2']					= "varchar(30)";
	$perintahstruct['tblpelang']['Hub_Telp_2']					= "varchar(20)";
	$perintahstruct['tblpelang']['Hubungi_3']					= "varchar(30)";
	$perintahstruct['tblpelang']['Hub_Telp_3']					= "varchar(20)";
	$perintahstruct['tblpelang']['Email']						= "varchar(50)";
	$perintahstruct['tblpelang']['Website']						= "varchar(30)";
	$perintahstruct['tblpelang']['Sps_Disc']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['Sps_DiscIn']					= "numeric(5,2) DEFAULT 0";
	$perintahstruct['tblpelang']['Sps_Disc2']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['Sps_Disc2B']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['Sps_Disc2C']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['Disc_Pri']					= "tinyint unsigned";
	$perintahstruct['tblpelang']['Disc_Pri2']					= "tinyint unsigned";
	$perintahstruct['tblpelang']['Term_Crd']					= "smallint unsigned";
	$perintahstruct['tblpelang']['MU_Credit']					= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblpelang']['Max_Crd']						= "numeric(12,0)";
	$perintahstruct['tblpelang']['Max_Crd2']					= "numeric(3,0)";
	$perintahstruct['tblpelang']['Max_Crd_Pr']					= "numeric(1,0)";
	$perintahstruct['tblpelang']['Max2_Crd']					= "numeric(12,0)";
	$perintahstruct['tblpelang']['Max2_Crd2']					= "numeric(3,0)";
	$perintahstruct['tblpelang']['Max2_Crd_P']					= "numeric(1,0)";
	$perintahstruct['tblpelang']['Max3_Crd']					= "numeric(3,0)";
	$perintahstruct['tblpelang']['Max3_Crd_P']					= "numeric(1,0)";
	$perintahstruct['tblpelang']['Tanpa_CRDC']					= "boolean";
	$perintahstruct['tblpelang']['FakPjk_No']					= "varchar(20)";
	$perintahstruct['tblpelang']['PPN_Tipe']					= "numeric(1,0)";
	$perintahstruct['tblpelang']['PPN_Pers']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['PPN_PersEx']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['SetAdj1Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['SetAdj2Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['SetAdj3Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['SetAdj4Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['SetAdj5Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['Divisi_ID']					= "numeric(3,0)";		// Untuk keperluan import balik cabang bersangkutan...
	$perintahstruct['tblpelang']['Sales']						= "numeric(6,0)";		// Untuk keperluan import balik cabang bersangkutan...
	$perintahstruct['tblpelang']['Collector']					= "numeric(6,0)";		// Untuk keperluan import balik cabang bersangkutan...
	$perintahstruct['tblpelang']['Non_Aktif']					= "date";
	$perintahstruct['tblpelang']['Black_List']					= "boolean";
	$perintahstruct['tblpelang']['MU_Jual']						= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblpelang']['Harga_Jual']					= "tinyint unsigned";
	$perintahstruct['tblpelang']['User_Lvl']					= "char(30)";
	$perintahstruct['tblpelang']['Picture']						= "varchar(180)";
	$perintahstruct['tblpelang']['Cat_Show']					= "boolean";
	$perintahstruct['tblpelang']['Catatan']						= "varchar(500)";
	$perintahstruct['tblpelang']['PJ_Gudang']					= "numeric(2,0)";		// Untuk keperluan import balik cabang bersangkutan...
	$perintahstruct['tblpelang']['PJ_MaUang']					= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblpelang']['PJ_Sales']					= "numeric(6,0)";		// Untuk keperluan import balik cabang bersangkutan...
	$perintahstruct['tblpelang']['PJ_DiscPer']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['PJ_DiscNil']					= "numeric(11,2)";
	$perintahstruct['tblpelang']['PJ_Adj1Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['PJ_Adj2Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['PJ_Adj3Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['PJ_Adj4Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['PJ_Adj5Per']					= "numeric(5,2)";
	$perintahstruct['tblpelang']['PJ_Adj1Nil']					= "numeric(11,2)";
	$perintahstruct['tblpelang']['PJ_Adj2Nil']					= "numeric(11,2)";
	$perintahstruct['tblpelang']['PJ_Adj3Nil']					= "numeric(11,2)";
	$perintahstruct['tblpelang']['PJ_Adj4Nil']					= "numeric(11,2)";
	$perintahstruct['tblpelang']['PJ_Adj5Nil']					= "numeric(11,2)";
	$perintahstruct['tblpelang']['PJ_Catatan']					= "varchar(50)";
	$perintahstruct['tblpelang']['Card_SN']						= "varchar(10)";
	$perintahstruct['tblpelang']['Export_Oleh']					= "varchar(10)";
	$perintahstruct['tblpelang']['Export_DateTime']				= "datetime";
	$perintahstruct['tblpelang']['Export_IP']					= "varchar(30)";
	$perintahstruct['tblpelang']['Export_Mac']					= "varchar(30)";
	$perintahstruct['tblpelang']['Input_Oleh']					= "varchar(10)";
	$perintahstruct['tblpelang']['Input_DateTime']				= "datetime";
	$perintahstruct['tblpelang']['Ubah_Oleh']					= "varchar(10)";
	$perintahstruct['tblpelang']['Ubah_DateTime']				= "datetime";
	$perintahstruct['tblpelang']['Hapus_Oleh']					= "varchar(10)";
	$perintahstruct['tblpelang']['Hapus_DateTime']				= "datetime";
	$perintahstruct['tblpelang']['PrimaryKey']					= "Kode";
	$perintahstruct['tblpelang']['UniqueKey']					= array();
	$perintahstruct['tblpelang']['UniqueKey']['Kode']			= "Kode";
	$perintahstruct['tblpelang']['Key']							= array();
	$perintahstruct['tblpelang']['Key']['KodeCabang']			= "KodeCabang";

	$perintahstruct['tblitem'] = array();
	$perintahstruct['tblitem']['Kode']							= "char(20) NOT NULL";
	$perintahstruct['tblitem']['Kode_C_2']						= "char(20)";
	$perintahstruct['tblitem']['Kode_C_3']						= "char(20)";
	$perintahstruct['tblitem']['Kode_C_4']						= "char(20)";
	$perintahstruct['tblitem']['Kode_C_5']						= "char(20)";
	$perintahstruct['tblitem']['Barcode']						= "char(30)";
	$perintahstruct['tblitem']['Hide']							= "boolean";
	$perintahstruct['tblitem']['Group_Stk']						= "varchar(30)";
	$perintahstruct['tblitem']['Group_St2']						= "varchar(30)";
	$perintahstruct['tblitem']['Group_St3']						= "varchar(30)";
	$perintahstruct['tblitem']['Jenis']							= "tinyint unsigned";
	$perintahstruct['tblitem']['Serial_ID']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Serial_2']						= "boolean";
	$perintahstruct['tblitem']['Nama']							= "varchar(100)";
	$perintahstruct['tblitem']['NamaEx1']						= "varchar(30)";
	$perintahstruct['tblitem']['NamaEx2']						= "varchar(20)";
	$perintahstruct['tblitem']['NamaEx3']						= "varchar(5)";
	$perintahstruct['tblitem']['Nama_2']						= "varchar(50)";
	$perintahstruct['tblitem']['Ext_Info_1']					= "varchar(30)";
	$perintahstruct['tblitem']['Ext_Info_2']					= "varchar(30)";
	$perintahstruct['tblitem']['Ext_Info_3']					= "varchar(30)";
	$perintahstruct['tblitem']['Quan_Pict']						= "varchar(12)";
	$perintahstruct['tblitem']['Expired']						= "boolean";
	$perintahstruct['tblitem']['Non_Pajak']						= "boolean";
	$perintahstruct['tblitem']['Tnp_Harga']						= "boolean";
	$perintahstruct['tblitem']['Tnp_DisGlb']					= "boolean";
	$perintahstruct['tblitem']['Tnp_Adj01']						= "boolean";
	$perintahstruct['tblitem']['Tnp_Adj02']						= "boolean";
	$perintahstruct['tblitem']['Tnp_Adj03']						= "boolean";
	$perintahstruct['tblitem']['Tnp_Adj04']						= "boolean";
	$perintahstruct['tblitem']['Tnp_Adj05']						= "boolean";
	$perintahstruct['tblitem']['Flx_Harga']						= "boolean";
	$perintahstruct['tblitem']['Blh_BwhHbl']					= "boolean";
	$perintahstruct['tblitem']['Tnp_CtkBar']					= "boolean";
	$perintahstruct['tblitem']['Not_Availa']					= "boolean";
	$perintahstruct['tblitem']['Itm_PurcOr']					= "boolean";
	$perintahstruct['tblitem']['Itm_TrmStk']					= "boolean";
	$perintahstruct['tblitem']['Itm_Pembel']					= "boolean";
	$perintahstruct['tblitem']['Itm_RetPem']					= "boolean";
	$perintahstruct['tblitem']['Itm_Quotat']					= "boolean";
	$perintahstruct['tblitem']['Itm_SalOrd']					= "boolean";
	$perintahstruct['tblitem']['Itm_KlrStk']					= "boolean";
	$perintahstruct['tblitem']['Itm_PenjEc']					= "boolean";
	$perintahstruct['tblitem']['Itm_Penjua']					= "boolean";
	$perintahstruct['tblitem']['Itm_BonPen']					= "boolean";
	$perintahstruct['tblitem']['Itm_RetPen']					= "boolean";
	$perintahstruct['tblitem']['Itm_StkPin']					= "boolean";
	$perintahstruct['tblitem']['Itm_StkTra']					= "boolean";
	$perintahstruct['tblitem']['Itm_StkRep']					= "boolean";
	$perintahstruct['tblitem']['Itm_StkMas']					= "boolean";
	$perintahstruct['tblitem']['Itm_StkKlr']					= "boolean";
	$perintahstruct['tblitem']['Tipe_Satu']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_01']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_02']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_03']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_04']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_05']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_06']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_07']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_08']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_09']						= "varchar(10)";
	$perintahstruct['tblitem']['Satuan_10']						= "varchar(10)";
	$perintahstruct['tblitem']['Sat_K_01']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_02']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_03']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_04']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_05']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_06']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_07']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_08']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_09']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_K_10']						= "numeric(11,4)";
	$perintahstruct['tblitem']['Sat_Def']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_Ecr']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_Out']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_Out_2']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_Out_D']						= "numeric(1,0)";
	$perintahstruct['tblitem']['Sat_Beli']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_Min']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_J_01']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_J_02']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_J_03']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_J_04']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Sat_J_05']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Jml_Beli']						= "numeric(9,3)";
	$perintahstruct['tblitem']['Jml_Min']						= "numeric(9,3)";
	$perintahstruct['tblitem']['Jml_J_01']						= "numeric(9,3)";
	$perintahstruct['tblitem']['Jml_J_02']						= "numeric(9,3)";
	$perintahstruct['tblitem']['Jml_J_03']						= "numeric(9,3)";
	$perintahstruct['tblitem']['Jml_J_04']						= "numeric(9,3)";
	$perintahstruct['tblitem']['Jml_J_05']						= "numeric(9,3)";
	$perintahstruct['tblitem']['Kurs_Jual']						= "numeric(1,0)";
	$perintahstruct['tblitem']['MU_H_Beli']						= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblitem']['MU_H_Min']						= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblitem']['MU_H_J_01']						= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblitem']['MU_H_J_02']						= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblitem']['MU_H_J_03']						= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblitem']['MU_H_J_04']						= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblitem']['MU_H_J_05']						= "numeric(2,0)";		// Wajib Rupiah...
	$perintahstruct['tblitem']['Harga_Beli']					= "numeric(11,2)";
	$perintahstruct['tblitem']['Harga_Min']						= "numeric(11,2)";
	$perintahstruct['tblitem']['Harga_J_01']					= "numeric(11,2)";
	$perintahstruct['tblitem']['Harga_J_02']					= "numeric(11,2)";
	$perintahstruct['tblitem']['Harga_J_03']					= "numeric(11,2)";
	$perintahstruct['tblitem']['Harga_J_04']					= "numeric(11,2)";
	$perintahstruct['tblitem']['Harga_J_05']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx1_Beli']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx1_Min']						= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx1_J_01']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx1_J_02']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx1_J_03']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx1_J_04']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx1_J_05']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx2_Beli']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx2_Min']						= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx2_J_01']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx2_J_02']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx2_J_03']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx2_J_04']					= "numeric(11,2)";
	$perintahstruct['tblitem']['HgEx2_J_05']					= "numeric(11,2)";
	$perintahstruct['tblitem']['Har_J_01_P']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Har_J_02_P']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Har_J_03_P']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Har_J_04_P']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Har_J_05_P']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Har_Min_P']						= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc_Bl_P']						= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc_Bl_P2']					= "numeric(5,2) DEFAULT 0";
	$perintahstruct['tblitem']['Disc_Bl_P3']					= "numeric(5,2) DEFAULT 0";
	$perintahstruct['tblitem']['Disc1_J_01']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc2_J_01']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc3_J_01']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc1_J_02']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc2_J_02']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc3_J_02']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc1_J_03']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc2_J_03']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc3_J_03']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc1_J_04']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc2_J_04']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc3_J_04']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc1_J_05']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc2_J_05']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Disc3_J_05']					= "numeric(5,2)";
	$perintahstruct['tblitem']['Min_Stock']						= "numeric(12,3)";
	$perintahstruct['tblitem']['Min_Stk_St']					= "numeric(2,0)";
	$perintahstruct['tblitem']['Max_Stock']						= "numeric(12,3)";
	$perintahstruct['tblitem']['Max_Stk_St']					= "numeric(2,0)";
	$perintahstruct['tblitem']['Min_Jual']						= "numeric(12,3)";
	$perintahstruct['tblitem']['Min_Jl_St']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Max_Jual']						= "numeric(12,3)";
	$perintahstruct['tblitem']['Max_Jl_St']						= "numeric(2,0)";
	$perintahstruct['tblitem']['Cat_Show']						= "boolean";
	$perintahstruct['tblitem']['Catatan']						= "varchar(50)";
	$perintahstruct['tblitem']['Export_Oleh']					= "varchar(10)";
	$perintahstruct['tblitem']['Export_DateTime']				= "datetime";
	$perintahstruct['tblitem']['Export_IP']						= "varchar(30)";
	$perintahstruct['tblitem']['Export_Mac']					= "varchar(30)";
	$perintahstruct['tblitem']['Input_Oleh']					= "varchar(10)";
	$perintahstruct['tblitem']['Input_DateTime']				= "datetime";
	$perintahstruct['tblitem']['Ubah_Oleh']						= "varchar(10)";
	$perintahstruct['tblitem']['Ubah_DateTime']					= "datetime";
	$perintahstruct['tblitem']['Hapus_Oleh']					= "varchar(10)";
	$perintahstruct['tblitem']['Hapus_DateTime']				= "datetime";
	$perintahstruct['tblitem']['PrimaryKey']					= "Kode";
	$perintahstruct['tblitem']['UniqueKey']						= array();
	$perintahstruct['tblitem']['UniqueKey']['Kode']				= "Kode";
	$perintahstruct['tblitem']['Key']							= array();
	$perintahstruct['tblitem']['Key']['Nama']					= "Nama";

	$perintahstruct['tblpembel'] = array();
	$perintahstruct['tblpembel']['KodeCabang']					= "smallint unsigned NOT NULL";
	$perintahstruct['tblpembel']['TelahImport']					= "boolean";
	$perintahstruct['tblpembel']['PembelID']					= "int unsigned NOT NULL AUTO_INCREMENT";
	$perintahstruct['tblpembel']['ExportID']					= "int unsigned NOT NULL";
	$perintahstruct['tblpembel']['PurOrdID']					= "int unsigned";
	$perintahstruct['tblpembel']['Divisi_ID']					= "numeric(3,0)";
	$perintahstruct['tblpembel']['JenPem_ID']					= "numeric(3,0)";
	$perintahstruct['tblpembel']['Perkir_1']					= "numeric(6,0)";
	$perintahstruct['tblpembel']['Perkir_2']					= "numeric(6,0)";
	$perintahstruct['tblpembel']['Barang_Trm']					= "boolean";
	$perintahstruct['tblpembel']['No_Milik']					= "numeric(1,0)";
	$perintahstruct['tblpembel']['No_Mlk_Csh']					= "boolean";
	$perintahstruct['tblpembel']['No']							= "varchar(30)";
	$perintahstruct['tblpembel']['No_Ex1']						= "varchar(30)";
	$perintahstruct['tblpembel']['No_FakPjk']					= "varchar(30)";
	$perintahstruct['tblpembel']['Tgl_FakPjk']					= "date";
	$perintahstruct['tblpembel']['Gudang']						= "varchar(30)";
	$perintahstruct['tblpembel']['Tanggal']						= "date";
	$perintahstruct['tblpembel']['Tanggal2']					= "date";
	$perintahstruct['tblpembel']['Pukul']						= "char(5)";
	$perintahstruct['tblpembel']['Ven_Nama']					= "varchar(50)";
	$perintahstruct['tblpembel']['Ven_Alamat']					= "varchar(100)";
	$perintahstruct['tblpembel']['MaUang']						= "numeric(2,0)";	// Wajib Rupiah ...
	$perintahstruct['tblpembel']['Kurs']						= "numeric(11,4)";
	$perintahstruct['tblpembel']['Tot_Harga']					= "numeric(13,2)";
	$perintahstruct['tblpembel']['Tot_HarEx1']					= "numeric(13,2)";
	$perintahstruct['tblpembel']['Tot_HarEx2']					= "numeric(13,2)";
	$perintahstruct['tblpembel']['Tot_Disc']					= "numeric(11,2)";
	$perintahstruct['tblpembel']['Tot_Retur']					= "numeric(11,2)";
	$perintahstruct['tblpembel']['Disc_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblpembel']['PPN_Tipe']					= "numeric(1,0)";
	$perintahstruct['tblpembel']['PPN_Pers']					= "numeric(5,2)";
	$perintahstruct['tblpembel']['PPN_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblpembel']['Adj_01']						= "numeric(11,2)";
	$perintahstruct['tblpembel']['Adj_02']						= "numeric(11,2)";
	$perintahstruct['tblpembel']['Adj_03']						= "numeric(11,2)";
	$perintahstruct['tblpembel']['Adj_04']						= "numeric(11,2)";
	$perintahstruct['tblpembel']['Adj_05']						= "numeric(11,2)";
	$perintahstruct['tblpembel']['Deposit']						= "numeric(13,2)";
	$perintahstruct['tblpembel']['Term_Crd']					= "numeric(3,0)";
	$perintahstruct['tblpembel']['Catatan']						= "varchar(100)";
	$perintahstruct['tblpembel']['Catatan_2']					= "varchar(100)";
	$perintahstruct['tblpembel']['Catatan_3']					= "varchar(100)";
	$perintahstruct['tblpembel']['Saldo_Awal']					= "boolean";
	$perintahstruct['tblpembel']['Als_Batal']					= "varchar(50)";
	$perintahstruct['tblpembel']['Clear_AP']					= "date";
	$perintahstruct['tblpembel']['Konf_Oleh']					= "varchar(10)";
	$perintahstruct['tblpembel']['Konf_DateTime']				= "datetime";
	$perintahstruct['tblpembel']['Export_Oleh']					= "varchar(10)";
	$perintahstruct['tblpembel']['Export_DateTime']				= "datetime";
	$perintahstruct['tblpembel']['Export_IP']					= "varchar(30)";
	$perintahstruct['tblpembel']['Export_Mac']					= "varchar(30)";
	$perintahstruct['tblpembel']['Input_Oleh']					= "varchar(10)";
	$perintahstruct['tblpembel']['Input_DateTime']				= "datetime";
	$perintahstruct['tblpembel']['Ubah_Oleh']					= "varchar(10)";
	$perintahstruct['tblpembel']['Ubah_DateTime']				= "datetime";
	$perintahstruct['tblpembel']['Hapus_Oleh']					= "varchar(10)";
	$perintahstruct['tblpembel']['Hapus_DateTime']				= "datetime";
	$perintahstruct['tblpembel']['PrimaryKey']					= "PembelID";
	$perintahstruct['tblpembel']['UniqueKey']					= array();
	$perintahstruct['tblpembel']['UniqueKey']['PembelID']		= "PembelID";
	$perintahstruct['tblpembel']['Key']							= array();
	$perintahstruct['tblpembel']['Key']['KodeCabang']			= "KodeCabang";
	$perintahstruct['tblpembel']['Key']['ExportID']				= "ExportID";

	$perintahstruct['tblpembed'] = array();
	$perintahstruct['tblpembed']['PembelID']					= "int unsigned NOT NULL";
	$perintahstruct['tblpembed']['Perkir_ID']					= "numeric(6,0)";
	$perintahstruct['tblpembed']['ItemKode']					= "char(20) NOT NULL";
	$perintahstruct['tblpembed']['ItemNama']					= "varchar(150)";
	$perintahstruct['tblpembed']['ItemGudang']					= "varchar(30)";
	$perintahstruct['tblpembed']['Stock_Non']					= "varchar(100)";
	$perintahstruct['tblpembed']['StkSer_ID']					= "int unsigned";
	$perintahstruct['tblpembed']['StkSer_1']					= "varchar(20)";
	$perintahstruct['tblpembed']['StkSer_2']					= "varchar(20)";
	$perintahstruct['tblpembed']['Satuan']						= "varchar(10)";
	$perintahstruct['tblpembed']['Satuan_ID']					= "numeric(2,0)";
	$perintahstruct['tblpembed']['Jumlah']						= "numeric(9,3)";
	$perintahstruct['tblpembed']['Harga']						= "numeric(13,2)";
	$perintahstruct['tblpembed']['Harga_Ex1']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Harga_Ex2']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Disc_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Mast_Disc']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Mast_PPN']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Mast_Adj_1']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Mast_Adj_2']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Mast_Adj_3']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Mast_Adj_4']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Mast_Adj_5']					= "numeric(11,2)";
	$perintahstruct['tblpembed']['Expired']						= "date";
	$perintahstruct['tblpembed']['Catatan']						= "varchar(50)";
	$perintahstruct['tblpembed']['Tgl_Hapus']					= "date";
	$perintahstruct['tblpembed']['Key']							= array();
	$perintahstruct['tblpembed']['Key']['PembelID']				= "PembelID";

	$perintahstruct['tblpenjua'] = array();
	$perintahstruct['tblpenjua']['KodeCabang']					= "smallint unsigned NOT NULL";
	$perintahstruct['tblpenjua']['PenjuaID']					= "int unsigned NOT NULL AUTO_INCREMENT";
	$perintahstruct['tblpenjua']['ExportID']					= "int unsigned NOT NULL DEFAULT 0";
	$perintahstruct['tblpenjua']['SalOrdID']					= "int unsigned";
	$perintahstruct['tblpenjua']['Point']						= "int unsigned";
	$perintahstruct['tblpenjua']['EcrLst']						= "varchar(20)";
	$perintahstruct['tblpenjua']['Divisi_ID']					= "numeric(3,0)";
	$perintahstruct['tblpenjua']['JenPen_ID']					= "numeric(3,0)";
	$perintahstruct['tblpenjua']['Perkir_1']					= "numeric(6,0)";
	$perintahstruct['tblpenjua']['Perkir_2']					= "numeric(6,0)";
	$perintahstruct['tblpenjua']['Barang_Klr']					= "boolean";
	$perintahstruct['tblpenjua']['Linked']						= "numeric(1,0)";
	$perintahstruct['tblpenjua']['No_Milik']					= "numeric(1,0)";
	$perintahstruct['tblpenjua']['No_Mlk_Csh']					= "boolean";
	$perintahstruct['tblpenjua']['No']							= "numeric(8,0)";
	$perintahstruct['tblpenjua']['No_C']						= "char(10)";
	$perintahstruct['tblpenjua']['No_Pjk_Pre']					= "numeric(1,0)";
	$perintahstruct['tblpenjua']['No_Pjk']						= "numeric(8,0)";
	$perintahstruct['tblpenjua']['PO']							= "varchar(30)";
	$perintahstruct['tblpenjua']['Gudang']						= "varchar(30)";
	$perintahstruct['tblpenjua']['Tanggal']						= "date";
	$perintahstruct['tblpenjua']['Tgl_Pajak']					= "date";
	$perintahstruct['tblpenjua']['Pukul']						= "char(5)";
	$perintahstruct['tblpenjua']['PelangKode']					= "char(20)";
	$perintahstruct['tblpenjua']['Pel_Nama']					= "varchar(50)";
	$perintahstruct['tblpenjua']['Pel_Alamat']					= "varchar(100)";
	$perintahstruct['tblpenjua']['MaUang']						= "numeric(2,0)";	// Wajib Rupiah ...
	$perintahstruct['tblpenjua']['Kurs']						= "numeric(11,4)";
	$perintahstruct['tblpenjua']['Kurs_Pajak']					= "numeric(11,4)";
	$perintahstruct['tblpenjua']['Tot_Harga']					= "numeric(13,2)";
	$perintahstruct['tblpenjua']['Tot_HarEx1']					= "numeric(13,2)";
	$perintahstruct['tblpenjua']['Tot_HarEx2']					= "numeric(13,2)";
	$perintahstruct['tblpenjua']['Tot_Disc']					= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Tot_Pajak']					= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Tot_Retur']					= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Disc_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Disc_PersT']					= "numeric(5,2)";
	$perintahstruct['tblpenjua']['PPN_Tipe']					= "numeric(1,0)";
	$perintahstruct['tblpenjua']['PPN_Pers']					= "numeric(5,2)";
	$perintahstruct['tblpenjua']['PPN_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Adj_01']						= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Adj_02']						= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Adj_03']						= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Adj_04']						= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Adj_05']						= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Deposit']						= "numeric(13,2)";
	$perintahstruct['tblpenjua']['Tgl_Lunas']					= "date";
	$perintahstruct['tblpenjua']['Lunas']						= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Lun_Tipe_1']					= "numeric(2,0)";
	$perintahstruct['tblpenjua']['Lun_Doc_1']					= "varchar(30)";
	$perintahstruct['tblpenjua']['Lun_Doc_1A']					= "varchar(30)";
	$perintahstruct['tblpenjua']['Lunas_1']						= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Charges_1']					= "numeric(11,2)";
	$perintahstruct['tblpenjua']['Term_Crd']					= "numeric(3,0)";
	$perintahstruct['tblpenjua']['Sales']						= "varchar(30)";
	$perintahstruct['tblpenjua']['Sales_Kom']					= "numeric(5,2)";
	$perintahstruct['tblpenjua']['Supir']						= "varchar(30)";
	$perintahstruct['tblpenjua']['Catatan']						= "varchar(100)";
	$perintahstruct['tblpenjua']['Catatan_2']					= "varchar(100)";
	$perintahstruct['tblpenjua']['Catatan_3']					= "varchar(100)";
	$perintahstruct['tblpenjua']['Saldo_Awal']					= "boolean";
	$perintahstruct['tblpenjua']['Als_Batal']					= "varchar(50)";
	$perintahstruct['tblpenjua']['Clear_AR']					= "date";
	$perintahstruct['tblpenjua']['Cetak_Oleh']					= "varchar(10)";
	$perintahstruct['tblpenjua']['Cetak_DateTime']				= "datetime";
	$perintahstruct['tblpenjua']['Ceta2_Oleh']					= "varchar(10)";
	$perintahstruct['tblpenjua']['Ceta2_DateTime']				= "datetime";
	$perintahstruct['tblpenjua']['Konf_Oleh']					= "varchar(10)";
	$perintahstruct['tblpenjua']['Konf_DateTime']				= "datetime";
	$perintahstruct['tblpenjua']['Export_Oleh']					= "varchar(10)";
	$perintahstruct['tblpenjua']['Export_DateTime']				= "datetime";
	$perintahstruct['tblpenjua']['Export_IP']					= "varchar(30)";
	$perintahstruct['tblpenjua']['Export_Mac']					= "varchar(30)";
	$perintahstruct['tblpenjua']['Input_Oleh']					= "varchar(10)";
	$perintahstruct['tblpenjua']['Input_DateTime']				= "datetime";
	$perintahstruct['tblpenjua']['Ubah_Oleh']					= "varchar(10)";
	$perintahstruct['tblpenjua']['Ubah_DateTime']				= "datetime";
	$perintahstruct['tblpenjua']['Hapus_Oleh']					= "varchar(10)";
	$perintahstruct['tblpenjua']['Hapus_DateTime']				= "datetime";
	$perintahstruct['tblpenjua']['PrimaryKey']					= "PenjuaID";
	$perintahstruct['tblpenjua']['UniqueKey']					= array();
	$perintahstruct['tblpenjua']['UniqueKey']['PenjuaID']		= "PenjuaID";
	$perintahstruct['tblpenjua']['Key']							= array();
	$perintahstruct['tblpenjua']['Key']['KodeCabang']			= "KodeCabang";
	$perintahstruct['tblpenjua']['Key']['ExportID']				= "ExportID";

	$perintahstruct['tblpenjud'] = array();
	$perintahstruct['tblpenjud']['PenjuaID']					= "int unsigned NOT NULL";
	$perintahstruct['tblpenjud']['PembelID']					= "int unsigned";
	$perintahstruct['tblpenjud']['StkTraID']					= "int unsigned";
	$perintahstruct['tblpenjud']['Perkir_ID']					= "numeric(6,0)";
	$perintahstruct['tblpenjud']['ItemKode']					= "char(20) NOT NULL";
	$perintahstruct['tblpenjud']['ItemNama']					= "varchar(150)";
	$perintahstruct['tblpenjud']['ItemKode2']					= "char(20) NOT NULL";
	$perintahstruct['tblpenjud']['ItemNama2']					= "varchar(150)";
	$perintahstruct['tblpenjud']['ItemGudang']					= "varchar(30)";
	$perintahstruct['tblpenjud']['Stock_Non']					= "varchar(100)";
	$perintahstruct['tblpenjud']['StkSer_ID']					= "int unsigned";
	$perintahstruct['tblpenjud']['StkSer_1']					= "varchar(20)";
	$perintahstruct['tblpenjud']['StkSer_2']					= "varchar(20)";
	$perintahstruct['tblpenjud']['Sales']						= "varchar(30)";
	$perintahstruct['tblpenjud']['Satuan']						= "varchar(10)";
	$perintahstruct['tblpenjud']['Satuan_ID']					= "numeric(2,0)";
	$perintahstruct['tblpenjud']['Jumlah']						= "numeric(9,3)";
	$perintahstruct['tblpenjud']['Out_Satuan']					= "varchar(10)";
	$perintahstruct['tblpenjud']['Out_Satuan_ID']				= "numeric(2,0)";
	$perintahstruct['tblpenjud']['Out_Jumlah']					= "numeric(9,3)";
	$perintahstruct['tblpenjud']['Bon_Satuan']					= "varchar(10)";
	$perintahstruct['tblpenjud']['Bon_Satuan_ID']				= "numeric(2,0)";
	$perintahstruct['tblpenjud']['Bon_Jumlah']					= "numeric(9,3)";
	$perintahstruct['tblpenjud']['Harga']						= "numeric(13,2)";
	$perintahstruct['tblpenjud']['Harga_Ex1']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Harga_Ex2']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Disc_Pers']					= "numeric(5,2)";
	$perintahstruct['tblpenjud']['Disc_Pers2']					= "numeric(5,2)";
	$perintahstruct['tblpenjud']['Disc_Pers3']					= "numeric(5,2)";
	$perintahstruct['tblpenjud']['Disc_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['PPN_Pers']					= "numeric(5,2)";
	$perintahstruct['tblpenjud']['PPN_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Mast_Disc']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Mast_PPN']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Mast_Adj_1']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Mast_Adj_2']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Mast_Adj_3']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Mast_Adj_4']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Mast_Adj_5']					= "numeric(11,2)";
	$perintahstruct['tblpenjud']['Als_Batal']					= "varchar(50)";
	$perintahstruct['tblpenjud']['Expired']						= "date";
	$perintahstruct['tblpenjud']['Catatan']						= "varchar(50)";
	$perintahstruct['tblpenjud']['Tgl_Hapus']					= "date";
	$perintahstruct['tblpenjud']['Key']							= array();
	$perintahstruct['tblpenjud']['Key']['PenjuaID']				= "PenjuaID";

	$perintahstruct['tblretpen'] = array();
	$perintahstruct['tblretpen']['KodeCabang']					= "smallint unsigned NOT NULL";
	$perintahstruct['tblretpen']['RetPenID']					= "int unsigned NOT NULL AUTO_INCREMENT";
	$perintahstruct['tblretpen']['ExportID']					= "int unsigned NOT NULL DEFAULT 0";
	$perintahstruct['tblretpen']['Point']						= "int unsigned";
	$perintahstruct['tblretpen']['Divisi_ID']					= "numeric(3,0)";
	$perintahstruct['tblretpen']['JenPen_ID']					= "numeric(3,0)";
	$perintahstruct['tblretpen']['Cash']						= "boolean";
	$perintahstruct['tblretpen']['No']							= "numeric(8,0)";
	$perintahstruct['tblretpen']['No_C']						= "char(10)";
	$perintahstruct['tblretpen']['No_Pjk']						= "numeric(8,0)";
	$perintahstruct['tblretpen']['Gudang']						= "varchar(30)";
	$perintahstruct['tblretpen']['Tanggal']						= "date";
	$perintahstruct['tblretpen']['Tgl_Pajak']					= "date";
	$perintahstruct['tblretpen']['PelangKode']					= "char(20)";
	$perintahstruct['tblretpen']['Pel_Nama']					= "varchar(50)";
	$perintahstruct['tblretpen']['Pel_Alamat']					= "varchar(100)";
	$perintahstruct['tblretpen']['MaUang']						= "numeric(2,0)";	// Wajib Rupiah ...
	$perintahstruct['tblretpen']['Kurs']						= "numeric(11,4)";
	$perintahstruct['tblretpen']['Kurs_Pajak']					= "numeric(11,4)";
	$perintahstruct['tblretpen']['Tot_Harga']					= "numeric(13,2)";
	$perintahstruct['tblretpen']['Tot_HarEx1']					= "numeric(13,2)";
	$perintahstruct['tblretpen']['Tot_HarEx2']					= "numeric(13,2)";
	$perintahstruct['tblretpen']['Tot_Disc']					= "numeric(11,2)";
	$perintahstruct['tblretpen']['Disc_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblretpen']['Disc_PersT']					= "numeric(5,2)";
	$perintahstruct['tblretpen']['PPN_Tipe']					= "numeric(1,0)";
	$perintahstruct['tblretpen']['PPN_Pers']					= "numeric(5,2)";
	$perintahstruct['tblretpen']['PPN_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblretpen']['Adj_01']						= "numeric(11,2)";
	$perintahstruct['tblretpen']['Adj_02']						= "numeric(11,2)";
	$perintahstruct['tblretpen']['Adj_03']						= "numeric(11,2)";
	$perintahstruct['tblretpen']['Adj_04']						= "numeric(11,2)";
	$perintahstruct['tblretpen']['Adj_05']						= "numeric(11,2)";
	$perintahstruct['tblretpen']['Term_Crd']					= "numeric(3,0)";
	$perintahstruct['tblretpen']['Sales']						= "varchar(30)";
	$perintahstruct['tblretpen']['Catatan']						= "varchar(100)";
	$perintahstruct['tblretpen']['Catatan_2']					= "varchar(100)";
	$perintahstruct['tblretpen']['Catatan_3']					= "varchar(100)";
	$perintahstruct['tblretpen']['Als_Batal']					= "varchar(50)";
	$perintahstruct['tblretpen']['Clear_AR']					= "date";
	$perintahstruct['tblretpen']['Cetak_Oleh']					= "varchar(10)";
	$perintahstruct['tblretpen']['Cetak_DateTime']				= "datetime";
	$perintahstruct['tblretpen']['Konf_Oleh']					= "varchar(10)";
	$perintahstruct['tblretpen']['Konf_DateTime']				= "datetime";
	$perintahstruct['tblretpen']['Export_Oleh']					= "varchar(10)";
	$perintahstruct['tblretpen']['Export_DateTime']				= "datetime";
	$perintahstruct['tblretpen']['Export_IP']					= "varchar(30)";
	$perintahstruct['tblretpen']['Export_Mac']					= "varchar(30)";
	$perintahstruct['tblretpen']['Input_Oleh']					= "varchar(10)";
	$perintahstruct['tblretpen']['Input_DateTime']				= "datetime";
	$perintahstruct['tblretpen']['Ubah_Oleh']					= "varchar(10)";
	$perintahstruct['tblretpen']['Ubah_DateTime']				= "datetime";
	$perintahstruct['tblretpen']['Hapus_Oleh']					= "varchar(10)";
	$perintahstruct['tblretpen']['Hapus_DateTime']				= "datetime";
	$perintahstruct['tblretpen']['PrimaryKey']					= "RetPenID";
	$perintahstruct['tblretpen']['UniqueKey']					= array();
	$perintahstruct['tblretpen']['UniqueKey']['RetPenID']		= "RetPenID";
	$perintahstruct['tblretpen']['Key']							= array();
	$perintahstruct['tblretpen']['Key']['KodeCabang']			= "KodeCabang";
	$perintahstruct['tblretpen']['Key']['ExportID']				= "ExportID";

	$perintahstruct['tblretpjd'] = array();
	$perintahstruct['tblretpjd']['RetPenID']					= "int unsigned NOT NULL";
	$perintahstruct['tblretpjd']['Perkir_ID']					= "numeric(6,0)";
	$perintahstruct['tblretpjd']['ItemKode']					= "char(20) NOT NULL";
	$perintahstruct['tblretpjd']['ItemNama']					= "varchar(150)";
	$perintahstruct['tblretpjd']['ItemGudang']					= "varchar(30)";
	$perintahstruct['tblretpjd']['Stock_Non']					= "varchar(100)";
	$perintahstruct['tblretpjd']['StkSer_ID']					= "int unsigned";
	$perintahstruct['tblretpjd']['StkSer_1']					= "varchar(20)";
	$perintahstruct['tblretpjd']['StkSer_2']					= "varchar(20)";
	$perintahstruct['tblretpjd']['Satuan']						= "varchar(10)";
	$perintahstruct['tblretpjd']['Satuan_ID']					= "numeric(2,0)";
	$perintahstruct['tblretpjd']['Jumlah']						= "numeric(9,3)";
	$perintahstruct['tblretpjd']['Harga']						= "numeric(13,2)";
	$perintahstruct['tblretpjd']['Harga_Ex1']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Harga_Ex2']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Disc_Pers']					= "numeric(5,2)";
	$perintahstruct['tblretpjd']['Disc_Pers2']					= "numeric(5,2)";
	$perintahstruct['tblretpjd']['Disc_Pers3']					= "numeric(5,2)";
	$perintahstruct['tblretpjd']['Disc_Nilai']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Mast_Disc']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Mast_PPN']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Mast_Adj_1']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Mast_Adj_2']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Mast_Adj_3']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Mast_Adj_4']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Mast_Adj_5']					= "numeric(11,2)";
	$perintahstruct['tblretpjd']['Catatan']						= "varchar(50)";
	$perintahstruct['tblretpjd']['Tgl_Hapus']					= "date";
	$perintahstruct['tblretpjd']['Key']							= array();
	$perintahstruct['tblretpjd']['Key']['RetPenID']				= "RetPenID";

	$perintahstruct['tblpeladd'] = array();
	$perintahstruct['tblpeladd']['KodeCabang']					= "smallint unsigned NOT NULL";
	$perintahstruct['tblpeladd']['PelAddID']					= "int unsigned NOT NULL AUTO_INCREMENT";
	$perintahstruct['tblpeladd']['PelangKode']					= "char(20)";
	$perintahstruct['tblpeladd']['Catatan']						= "varchar(50)";
	$perintahstruct['tblpeladd']['Point']						= "int unsigned";
	$perintahstruct['tblpeladd']['Input_Oleh']					= "varchar(10)";
	$perintahstruct['tblpeladd']['Input_DateTime']				= "datetime";
	$perintahstruct['tblpeladd']['PrimaryKey']					= "PelAddID";
	$perintahstruct['tblpeladd']['UniqueKey']					= array();
	$perintahstruct['tblpeladd']['UniqueKey']['PelAddID']		= "PelAddID";

	$perintahstruct['tblpelded'] = array();
	$perintahstruct['tblpelded']['KodeCabang']					= "smallint unsigned NOT NULL";
	$perintahstruct['tblpelded']['PelDedID']					= "int unsigned NOT NULL AUTO_INCREMENT";
	$perintahstruct['tblpelded']['PelangKode']					= "char(20)";
	$perintahstruct['tblpelded']['Catatan']						= "varchar(50)";
	$perintahstruct['tblpelded']['Point']						= "int unsigned";
	$perintahstruct['tblpelded']['Input_Oleh']					= "varchar(10)";
	$perintahstruct['tblpelded']['Input_DateTime']				= "datetime";
	$perintahstruct['tblpelded']['PrimaryKey']					= "PelDedID";
	$perintahstruct['tblpelded']['UniqueKey']					= array();
	$perintahstruct['tblpelded']['UniqueKey']['PelDedID']		= "PelDedID";

	foreach ( $perintahstruct as $table => $cols ) {

		if ( !VOIsTableExists( $table ) ) {

			$createtable = 'CREATE TABLE ' . $table . ' (';

			foreach ( $cols as $field => $detail ) {

				if ( $field == 'Key' ) {

					foreach ( $detail as $key => $keyvalue ) {
						$createtable = $createtable . 'KEY ' . $key . ' (' . $keyvalue . '),';
					}

				} elseif ( $field == 'UniqueKey' ) {

					foreach ( $detail as $unique => $uniquekeyvalue ) {
						if ( !array_key_exists('PrimaryKey',$cols) OR strpos( $cols['PrimaryKey'], $uniquekeyvalue ) === FALSE ) {
							$createtable = $createtable . 'UNIQUE INDEX ' . $unique . ' (' . $uniquekeyvalue . ' ASC),';
						}
					}

				} else {

					if ( $field == 'PrimaryKey' ) {
						$createtable = $createtable . 'PRIMARY KEY (' . $detail . '),';
					} else {
						$createtable = $createtable . $field . ' ' . $detail . ',';
					}

				}

			}

			if ( substr( $createtable, strlen($createtable) - 1, 1 ) == ',' ) {
				$createtable = substr( $createtable, 0, strlen($createtable) - 1 );
			}

			$createtable = $createtable . ') ENGINE=MyISAM DEFAULT CHARSET=utf8';

			if ( @DBQuery( $createtable ) ) {
				echo "Table $table berhasil dibuat...<br>";
			} else {
				die( "Error membuat table $table: " . DBError() . "<br><br>" . $createtable );
			}

			if ( $table == 'tblcontrol' ) {

				$perintahdb = "INSERT INTO tblcontrol (DBVersion) VALUES ('0')";

				@DBQuery( $perintahdb );

			}

			if ( $table == 'tbluser' ) {

				$pass = '123';

				$perintahdb = "INSERT INTO tbluser (User,Password,Level,InputBy,InputDateTime) VALUES ('Admin','$pass',1,-1,now())";

				@DBQuery( $perintahdb );

			}

			if ( $table == 'tblcabang' ) {

				$perintahdb = "INSERT INTO tblcabang (KodeCabang,NamaCabang,InputBy,InputDateTime) VALUES (1,'Pusat',-1,now())";

				@DBQuery( $perintahdb );

			}

		} else {

			$updatetable = 'ALTER TABLE ' . $table . ' ';
			$compareonly = $updatetable;

			$querycols = @DBQuery( 'SHOW FULL COLUMNS FROM ' . $table );

			$primarykey = '';

			$uniquekey = array();

			$key = array();

			$struct = array();

			if ( $querycols ) {

				while ( $querycol = DBFetchAssoc($querycols) ) {

					$struct[$querycol['Field']] = $querycol['Type'] . ( $querycol['Null'] == 'YES' ? '' : ' NOT NULL' ) . ' ' . strtoupper($querycol['Extra']);

					if ( $querycol['Key'] == 'PRI' ) {
						if ( $primarykey != '' ) {
							$primarykey = $primarykey . ',';
						}
						$primarykey = $primarykey . $querycol['Field'];
					}

					if ( $querycol['Key'] == 'PRI' OR $querycol['Key'] == 'UNI' ) {
						$uniquekey[$querycol['Field']] = $querycol['Field'];
					}

					if ( $querycol['Key'] == 'MUL' ) {
						$key[$querycol['Field']] = $querycol['Field'];
					}

				}

				if ( $primarykey != '' ) {
					$struct['PrimaryKey'] = $primarykey;
				}

				if ( $uniquekey ) {
					$struct['UniqueKey'] = $uniquekey;
				}

				if ( $key ) {
					$struct['Key'] = $key;
				}

				/* Menampilkan info ke layar ... *

				echo "===== $table =====<br>";

				foreach ( $struct as $field => $type ) {

					if ( $field == 'UniqueKey' ) {

						foreach ( $type as $unique => $uniquekeyvalue ) {
							echo "$field : $uniquekeyvalue<br>";
						}

					} elseif ( $field == 'Key' ) {

						foreach ( $type as $key => $keyvalue ) {
							echo "$field : $keyvalue<br>";
						}

					} else {

						echo "$field : $type<br>";

					}

				}
				
				echo "===== NEW >>> $table =====<br>";

				foreach ( $cols as $field => $type ) {

					if ( $field == 'UniqueKey' ) {

						foreach ( $type as $unique => $uniquekeyvalue ) {
							echo "$field : $uniquekeyvalue<br>";
						}

					} elseif ( $field == 'Key' ) {

						foreach ( $type as $key => $keyvalue ) {
							echo "$field : $keyvalue<br>";
						}

					} else {

						echo "$field : $type<br>";

					}

				}

				* sampai di sini */

				$structarray = $cols;

				foreach ( $struct as $field => $detail ) {

					if ( $field == 'Key' ) {

						foreach ( $detail as $key => $keyvalue ) {
							if ( !array_key_exists( 'Key', $structarray ) OR !array_key_exists( $key, $structarray['Key'] ) ) {
								$updatetable = $updatetable . 'DROP INDEX ' . $key . ', ';
							}
						}

					} elseif ( $field == 'UniqueKey' ) {

						foreach ( $detail as $unique => $uniquekeyvalue ) {
							if ( !array_key_exists( 'UniqueKey', $structarray ) OR !array_key_exists( $unique, $structarray['UniqueKey'] ) ) {
								if ( !array_key_exists( 'PrimaryKey', $struct ) OR strpos( $struct['PrimaryKey'], $uniquekeyvalue ) === false ) {
									$updatetable = $updatetable . 'DROP INDEX ' . $unique . ', ';
								}
							}
						}

					} else {

						if ( $field == 'PrimaryKey' ) {
							if ( !array_key_exists( 'PrimaryKey', $structarray ) ) {
								$updatetable = $updatetable . 'DROP PRIMARY KEY, ';
							}
						} else {
							if ( !array_key_exists( $field, $structarray ) ) {
								$updatetable = $updatetable . 'DROP COLUMN ' . $field . ', ';
							}
						}

					}

				}

				$lastfield = '';

				foreach ( $cols as $field => $detail ) {

					if ( $field == 'Key' ) {

						foreach ( $detail as $key => $keyvalue ) {
							if ( array_key_exists( 'Key', $struct ) AND array_key_exists( $key, $struct['Key'] ) ) {
								if ( strtoupper(trim($keyvalue)) != strtoupper(trim($struct['Key'][$keyvalue])) ) {
									$updatetable = $updatetable . 'DROP INDEX ' . $key . ', ';
									$updatetable = $updatetable . 'ADD INDEX ' . $key . ' (' . $keyvalue . ' ASC), ';
								}
							} else {
								$updatetable = $updatetable . 'ADD INDEX ' . $key . ' (' . $keyvalue . ' ASC), ';
							}
						}

					} elseif ( $field == 'UniqueKey' ) {

						foreach ( $detail as $unique => $uniquekeyvalue ) {
							if ( array_key_exists( 'UniqueKey', $struct ) AND array_key_exists( $unique, $struct['UniqueKey'] ) ) {
								if ( strtoupper(trim($uniquekeyvalue)) != strtoupper(trim($struct['UniqueKey'][$uniquekeyvalue])) ) {
									$updatetable = $updatetable . 'DROP INDEX ' . $unique . ', ';
									$updatetable = $updatetable . 'ADD UNIQUE INDEX ' . $unique . ' (' . $uniquekeyvalue . ' ASC), ';
								}
							} else {
								if ( !array_key_exists( 'PrimaryKey', $cols ) OR strpos( $cols['PrimaryKey'], $uniquekeyvalue ) === false ) {
									$updatetable = $updatetable . 'ADD UNIQUE INDEX ' . $unique . ' (' . $uniquekeyvalue . ' ASC), ';
								}
							}
						}

					} else {

						if ( $field == 'PrimaryKey' ) {
							if ( array_key_exists( 'PrimaryKey', $struct ) ) {
								if ( strtoupper(trim($detail)) != strtoupper(trim($struct['PrimaryKey'])) ) {
									$updatetable = $updatetable . 'DROP PRIMARY KEY, ';
									$updatetable = $updatetable . 'ADD PRIMARY KEY (' . $detail . '), ';
								}
							} else {
								$updatetable = $updatetable . 'ADD PRIMARY KEY (' . $detail . '), ';
							}
						} else {
							if ( !array_key_exists( $field, $struct ) ) {
								$updatetable = $updatetable . 'ADD COLUMN ' . $field . ' ' . $detail . ( $lastfield == '' ? ' FIRST' : ' AFTER ' . $lastfield ) . ', ';
							} else {
								if ( strtoupper(trim($detail)) != strtoupper(trim($struct[$field])) ) {
									$updatetable = $updatetable . 'CHANGE COLUMN ' . $field . ' ' . $field . ' ' . $detail . ', ';
								}
							}
							$lastfield = $field;
						}

					}

				}

				if ( substr( $updatetable, strlen($updatetable) - 2, 2 ) == ', ' ) {
					$updatetable = substr( $updatetable, 0, strlen($updatetable) - 2 );
				}

				if ( $compareonly != $updatetable ) {
					if ( @DBQuery( $updatetable ) ) {
						echo "Table '$table' berhasil diupdate...<br>";
					} else {
						die( "Error update table '$table': " . DBError() . "<br>" . $updatetable );
					}
				}

			} else {

				die( "Error update table '$table': " . DBError() . " [query columns] <br>" );

			}

		}

	}

	$perintahdb = "UPDATE tblcontrol SET DBVersion=" . DATABASE_VERSION;

	@DBQuery( $perintahdb );

	if ( $versilama == 12 ) {
		$perintahdb = "UPDATE tblpelang SET Sps_Disc2=Sps_Disc";
		@DBQuery( $perintahdb );
	}

	if ( $versilama == 12 or $versilama == 13 ) {
		$perintahdb = "UPDATE tblpelang SET Disc_Pri2=Disc_Pri";
		@DBQuery( $perintahdb );
	}
?>